// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlSettings.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__STRUCT_H_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/AdaptiveCruiseControlSettings in the package automotive_platform_msgs.
/**
  * Adaptive Cruise Control Settings Message
  * Contains the current settings/status of ACC
 */
typedef struct automotive_platform_msgs__msg__AdaptiveCruiseControlSettings
{
  std_msgs__msg__Header header;
  /// Current speed set point (m/sec)
  float set_speed;
  /// Discrete following location
  /// 0 = following distance is the minimum allowed distance
  /// n = following distance is the maximum allowed distance
  ///      where (n + 1) is the number of allowed distances
  uint16_t following_spot;
  /// Minimum distance relative to maximum allowed distance
  /// 0 to 1.0
  float min_percent;
  /// Distance between spots relative to maximum allowed
  /// distance
  /// 0 to 1.0
  float step_percent;
  /// Where CIPV is relative to the maximum allowed distance
  /// 0 = there isn't a detected CIPV
  /// 1.0 = the CIPV is at the maximum allowed distance
  /// The maximum allowed distance varies with speed
  float cipv_percent;
  /// The distance corresponding to 1.0 percent (meters)
  float max_distance;
} automotive_platform_msgs__msg__AdaptiveCruiseControlSettings;

// Struct for a sequence of automotive_platform_msgs__msg__AdaptiveCruiseControlSettings.
typedef struct automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence
{
  automotive_platform_msgs__msg__AdaptiveCruiseControlSettings * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} automotive_platform_msgs__msg__AdaptiveCruiseControlSettings__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__STRUCT_H_
